
	list		p=16f1824     
	#include	<p16f1824.inc> 


    __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_SWDTEN & _PWRTE_OFF & _MCLRE_OFF & _CP_OFF & _CPD_OFF & _BOREN_OFF & _CLKOUTEN_OFF & _IESO_OFF & _FCMEN_OFF
    __CONFIG _CONFIG2, _WRT_OFF & _PLLEN_OFF & _STVREN_OFF & _BORV_19 & _LVP_OFF
  	

		; definicia bitov IO
	#define		LED_0			PORTC,0
	#define		LED_1			PORTC,1
	#define		LED_2			PORTC,2
	#define		LED_3			PORTC,3
	#define		LED_4			PORTA,2
	#define		LED_5			PORTA,4

	
	CBLOCK		20h
		GPR_80B_BANK_0
		FLAG
		RX_BYTE
		count
	ENDC


	#define		spusti_program			FLAG,0

		
;***************************************************************************************************************************
	org		00h
	GOTO	START
;***************************************************************************************************************************
	org		004h
	goto 	prerusenie
;************************************************* PODPROGRAMY *************************************************************

								
											;-----u-----;
		 							; (2)+  ; Vdd	Vss ; (3)-
									;		; RA5	RA0 ; (4)PGD		
									; LED_5	; RA4	RA1 ; (5)PGC
	   								;(1)Vpp ; RA3	RA2 ; 	LED_4
									; RxD	; RC5	RC0 ; 	LED_0
									; TxD	; RC4	RC1 ;	LED_1
									; LED_3	; RC3	RC2 ;	LED_2
											;-----------;
nastavenie_PIC
		banksel TRISA
		movlw 	b'00000000' 
		movwf 	TRISA 
		movlw 	b'00100000' 
		movwf 	TRISC 
		banksel	OSCCON
		movlw	b'11110000'		; nastavenie interneho oscilatora na 32 MHz	
		movwf	OSCCON	
		movlw	.0				; jemne nastavenie frekvencie .0 = tovarenske nastavenie = 32MHz
		movwf	OSCTUNE
		banksel	RCSTA
		movlw	b'10000000'		;bit7 SPEN: Serial Port Enable bit
		movwf	RCSTA			;bit4 CREN: Continuous Receive Enable bit
		movlw	b'00000100'		;bit2 BRGH: High Baud Rate Select bit: 1 = High speed, 0 = Low speed
		movwf	TXSTA
		movlw	b'00000000'
		movwf	BAUDCON			; bit3: Baud Rate Generator is used: 1 = 16-bit, 0 = 8-bit	
		movlw	.104			; 19230 Bd/s - vid vypocet v exceli
		movwf	SPBRGL			; Baud Rate Generator
		banksel	INTCON
		movlw	b'11001000'		; GIE: Global Interrupt Enable ; PEIE: Peripheral Interrupt Enable
		movwf	INTCON
		banksel	PIE1
		movlw	b'00100000'		; povolenie prerusenia od: RX USART
		movwf	PIE1
		banksel	OPTION_REG
		movlw	b'00000000'		; bit 7 - Pull-up; bit 6 - volba hrany externeho prerusenia. 1 = nabezna hrana
		movwf	OPTION_REG
		banksel	WDTCON
		movlw	b'00010110'		;bit 7-6 Unimplemented; bit 5-1 prescale; bit 0 on/off
		movwf	WDTCON			; nastavenie WATCHDOG
		banksel ANSELA 	
		clrf 	ANSELA 			;digital I/O
		clrf 	ANSELC 			;Make RC<5:0> digital
		banksel PORTA	
	return



vycistenie_GPR_banky_0
		movlw	.80				 ; 80 bajtov GPR v kazdej banke
		movwf	GPR_80B_BANK_0
		clrf	FSR0H
		movlw	GPR_80B_BANK_0+1 ; druhy bajt GPR banky 0 (prvy bajt je pocitadlo GPR_80B_BANK_0)
		movwf	FSR0L
	opakuj_nulovanie_bajtov_0
		clrf	INDF0
		incf	FSR0L,f
		decfsz	GPR_80B_BANK_0
		goto	opakuj_nulovanie_bajtov_0
	return



USART_TXW
			banksel	WDTCON
			bsf		WDTCON,SWDTEN
			banksel	TXSTA
			bsf		TXSTA,TXEN			; Zapnutie TX USART
			banksel	TXREG
			movwf	TXREG				; Vlozenie W do vysielacieho registra, cim sa spusti vysielanie
			btfss	TXSTA,TRMT			
			goto	$-1					; Cakacia slucka na odvysielanie bajtu
			banksel	WDTCON
			bcf		WDTCON,SWDTEN
			banksel	TXSTA
			bcf		TXSTA,TXEN			; Zapnutie TX USART
			banksel	PORTA
	return



;**************************************************************************************************
;************************************ OBSLUHA PRERUSENIA ******************************************
;**************************************************************************************************


prerusenie		
		bcf		INTCON,GIE
		btfss	PIR1,RCIF
		goto	preskoc_int_rxd
				;Skopirovanie prijateho cisla z bufra Rx UART do internej premennej RX_BYTE
			banksel	RCREG
			movf	RCREG,w			; precitanie prijimacieho registra USART	
;			bcf		RCSTA,CREN
;			nop
;			bsf		RCSTA,CREN
			banksel	PORTA
			movwf	RX_BYTE	
			bsf		spusti_program
		preskoc_int_rxd
		bsf		INTCON,GIE	
	retfie



;**************************************************************************************************
;************************************* HLAVNY PROGRAM ******************************************
;**************************************************************************************************



START

	call	nastavenie_PIC
	call	vycistenie_GPR_banky_0
	clrf	PORTC
	clrf	PORTA
	banksel	RCSTA
	bsf		RCSTA,CREN
	banksel	PORTA

opakuj	

	btfss	spusti_program
	goto	preskoc_program
		bcf		spusti_program
		bcf		INTCON,GIE
	

		btfss	RX_BYTE,0
		goto	preskoc_LED_0_vyp
		btfsc	LED_0
		goto	preskoc_LED_0_zap
			bsf		LED_0
			goto	preskoc_LED_0_vyp
		preskoc_LED_0_zap
			bcf		LED_0
		preskoc_LED_0_vyp


		btfss	RX_BYTE,1
		goto	preskoc_LED_1_vyp
		btfsc	LED_1
		goto	preskoc_LED_1_zap
			bsf		LED_1
			goto	preskoc_LED_1_vyp
		preskoc_LED_1_zap
			bcf		LED_1
		preskoc_LED_1_vyp


		btfss	RX_BYTE,2
		goto	preskoc_LED_2_vyp
		btfsc	LED_2
		goto	preskoc_LED_2_zap
			bsf		LED_2
			goto	preskoc_LED_2_vyp
		preskoc_LED_2_zap
			bcf		LED_2
		preskoc_LED_2_vyp


		btfss	RX_BYTE,3
		goto	preskoc_LED_3_vyp
		btfsc	LED_3
		goto	preskoc_LED_3_zap
			bsf		LED_3
			goto	preskoc_LED_3_vyp
		preskoc_LED_3_zap
			bcf		LED_3
		preskoc_LED_3_vyp


		btfss	RX_BYTE,4
		goto	preskoc_LED_4_vyp
		btfsc	LED_4
		goto	preskoc_LED_4_zap
			bsf		LED_4
			nop
			bsf		LED_5
			goto	preskoc_LED_4_vyp
		preskoc_LED_4_zap
			bcf		LED_4
			nop
			bcf		LED_5
		preskoc_LED_4_vyp


		btfss	RX_BYTE,7
		goto	preskoc_vycistenie
			reset
		preskoc_vycistenie

		movf	RX_BYTE,w
		call	USART_TXW
		movlw	.49
		movwf	count
		opakuj_tx
			movf	count,w
			call	USART_TXW
		decfsz	count
		goto	opakuj_tx


		preskoc_tx

		bsf		INTCON,GIE

	preskoc_program			

	goto opakuj

    END

